﻿using MVB_RestBookService.CodeLists;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;



namespace MVB_RestBookService
{
    public partial class AutoCompleteForm : Form
    {
        //Member Variables
        private TextBox textBox;
        private CodeList codeList;



        /// <summary>
        /// Constructor.
        /// </summary>
        /// <param name="textBox">Textbox the selected Index Item will be inserted into.</param>
        /// <param name="codeList">CodeList containing the Keys and Values to index.</param>
        /// <param name="formTitle">Title for this Form.</param>
        public AutoCompleteForm(TextBox textBox, CodeList codeList, string formTitle)
        {
            InitializeComponent();

            this.textBox = textBox;
            this.codeList = codeList;
            this.Text = formTitle;

            waterMarkTextBox_search_TextChanged(null, null);
        }



        /// <summary>
        /// User changed Search Text, a new Rest-Request is needed.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void waterMarkTextBox_search_TextChanged(object sender, EventArgs e)
        {
            //Init DataGridView
            index_dataGridView.Rows.Clear();
            Dictionary<string, string> codes = codeList.getAllCodes();
            CultureInfo cultureInfo = CultureInfo.CurrentCulture;

            //Get all Keys and Values and add them to the DataGridView
            for (int i = 0; i < codes.Count; i++)
            {
                //Filter Values
                if (cultureInfo.CompareInfo.IndexOf(codes[codes.Keys.ElementAt<string>(i)], index_waterMarkTextBox_search.Text, CompareOptions.IgnoreCase) >= 0)
                {
                    index_dataGridView.Rows.Add();
                    index_dataGridView.Rows[index_dataGridView.Rows.Count - 1].Cells[0].Value = codes[codes.Keys.ElementAt<string>(i)];
                    index_dataGridView.Rows[index_dataGridView.Rows.Count - 1].Cells[1].Value = codes.Keys.ElementAt<string>(i);
                }
            }
        }



        /// <summary>
        /// Fired, if the user double-clicks at a title in the index_dataGridView.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void index_dataGridView_onDoubleClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            if (index_dataGridView.SelectedRows.Count > 0)
            {
                textBox.Text = index_dataGridView.SelectedRows[0].Cells[1].Value.ToString();
                this.Close();
            }
        }
    }
}
