﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MVB_RestBookService.CodeLists
{
    public class CodeList
    {
        //Statics
        protected readonly Dictionary<string, string> codes = new Dictionary<string, string>();



        /// <summary>
        /// Returns the Value of a specific CodeList Key.
        /// </summary>
        /// <param name="key">Key to look for.</param>
        /// <returns>The associated Value or "Unbekannt", if the key does not exist.</returns>
        public string getCodeListValue(string key)
        {
            try
            {
                return codes[key];
            }
            catch (Exception ex)
            {
                return "Unbekannt";
            }
        }



        /// <summary>
        /// Returns a readonly Dictionary with all Codes.
        /// </summary>
        /// <returns>The Dictionary with all Codes. Readonly.</returns>
        public Dictionary<string, string> getAllCodes()
        {
            return codes;
        }
    }
}
